--[[ Au Feu ! par Antoine Letouzey
     ameboure@yahoo.fr
     http://sexy-banane.mine.nu/~peter/jeux.php
]]

menu = nil
niveau = nil
allumette1 = nil
allumette2 = nil
allumette3 = nil
allumette4 = nil
allumette5 = nil
allumette6 = nil
continuer = nil

-- structures de données
-- feu = {idFen= [int], compteur = [int], hp = [int]}
-- perso = {idFen = [int], hp = [int], etat = [int], x [int], y [int]}
-- goutte d'eau = { x = [int], y = [int], v0_sin [float], v0_cos [float], t = [int], hp = [int] }
-- message = { x [int], y [int], typ = [int], t [int]}


-- chargement des images
Imfond = Image.load("datas/fond.png")
Imimmeuble = Image.load("datas/immeuble.png")
Imfeu = {}
Imfeu[0] = Image.load("datas/feu1.png")
Imfeu[1] = Image.load("datas/feu2.png")
Imperso = {}
Imperso[0] =  Image.load("datas/perso.png")
Imperso[1] = Image.load("datas/perso_echelle.png")
Imperso[2] = Image.load("datas/perso_echelle.png")
Imperso[3] = Image.load("datas/angel.png")
Imperso[4] = Image.load("datas/angel.png")
Imgoutte = Image.load("datas/goutte.png")
Imechelle = Image.load("datas/echelle.png")
Imdialogue = {}
Imdialogue[0] = Image.load("datas/help.png")
Imdialogue[1] = Image.load("datas/safe.png")
Imdialogue[2] = Image.load("datas/thanx.png")
Impause = Image.load("datas/pause.png")
Impausefond = Image.load("datas/menu.png")
Imgagne = Image.load("datas/gagne.png")
Imperdu = Image.load("datas/perdu.png")
n0 = Image.load("datas/00.png")
n1 = Image.load("datas/01.png")
n2 = Image.load("datas/02.png")
n3 = Image.load("datas/03.png")
n4 = Image.load("datas/04.png")
n5 = Image.load("datas/05.png")
n6 = Image.load("datas/06.png")
n7 = Image.load("datas/07.png")
n8 = Image.load("datas/08.png")
n9 = Image.load("datas/09.png")

--chargement des sons
Music.playFile("datas/music.s3m", true)
Music.volume(128)

    --constantes
TAILLE = 15
TAILLEPERSO = 40
TAILLEFEU = 35
CONTINUER = true
GRAVITE = 0.12 -- l'axe des y est a l'envres
POS_X = 470
POS_Y = 110
-- les etats d'une fenetre
NBFEN = 13
OK = 0
BRULE = 1
PERSO = 2
PERSO_BRULE = 3

     -- Variables globales --
fenetres = {}
fenetres[1]  = {x=249, y=30, etat=OK}
fenetres[2]  = {x=251, y=149, etat=OK}
fenetres[3]  = {x=252, y=226, etat=OK}
fenetres[4]  = {x=287, y=70, etat=OK}
fenetres[5]  = {x=287, y=187, etat=OK}
fenetres[6]  = {x=324, y=31, etat=OK}
fenetres[7]  = {x=324, y=110, etat=OK}
fenetres[8]  = {x=324, y=225, etat=OK}
fenetres[9]  = {x=360, y=70, etat=OK}
fenetres[10] = {x=361, y=224, etat=OK}
fenetres[11] = {x=431, y=33, etat=OK}
fenetres[12] = {x=431, y=109, etat=OK}
fenetres[13] = {x=431, y=186, etat=OK}

personages = {}
feux = {}
gouttes = {}
messages = {}
echelle = {x = 300, y = 250}

nbMorts = 0;
nbSauves = 0;
statut = "aucun";

-----------------------------------------------------------
-----------------------------------------------------------
-----------  fonctions  -----------------------------------
-----------------------------------------------------------
-----------------------------------------------------------


-- donne un nb au pif entre d et f
function proba(d, f)
   math.randomseed(math.random(1, os.time())/100*math.pi)
   math.random(); math.random(1,math.pi)
   return math.random(d, f)
end 


-- affiche un feu
function print_feu(f)
 local sprite
 if f.compteur > 10 then sprite = 0
 else sprite = 1 end
 local decalage = (40 - f.hp) / 2
 screen:blit(fenetres[f.idFen].x - TAILLEFEU/2, fenetres[f.idFen].y - TAILLEFEU + 10 + decalage, Imfeu[sprite])
 f.compteur = f.compteur+1
 if f.compteur > 20 then f.compteur = 1 end
end

-- affiche un perso
function print_perso(p)
 if (p.etat == 1 or p.etat == 2) then
 screen:blit(p.x - 8, p.y-12, Imperso[p.etat])
 end
end
function print_perso2(p)
 if (p.etat == 0) then
 screen:blit(fenetres[p.idFen].x - TAILLEPERSO/2-0.25, fenetres[p.idFen].y - TAILLEPERSO + 17, Imperso[0])
 end
end
function print_perso3(p)
 if (p.etat == 3 or p.etat == 4) then
 screen:blit(fenetres[p.idFen].x - TAILLEPERSO/2-2.5, p.y, Imperso[p.etat])
 end
end

-- affiche une goute d'eau
function print_goutte(g)
 screen:blit(g.x,g.y,Imgoutte)
end

--affiche un message
function print_message(i,m)
 if m.t < 0 then table.remove(messages,i)
 else
  m.t = m.t -1
  screen:blit(m.x-60,m.y-12,Imdialogue[m.typ])
 end
end

-- ajoute un feu (on suppose que la fenetre ne brule pas deja)
function new_feu(fen,hp)
 if (fenetres[fen].etat == BRULE or fenetres[fen].etat == PERSO_BRULE) then return end
 if fenetres[fen].etat == PERSO then
  fenetres[fen].etat = PERSO_BRULE
  new_message(fenetres[fen].x + TAILLE/2, fenetres[fen].y - (TAILLE +20) , 0)
 else fenetres[fen].etat = BRULE
 end
 table.insert(feux,{idFen = fen, compteur = 0, hp = hp})
end

-- ajoute un perso (on suppose que la fenetre est libre)
function new_perso(fen,hp)
 fenetres[fen].etat = fenetres[fen].etat + PERSO
 table.insert(personages,{idFen = fen, hp = hp, etat = 0, x = 0, y = 0})
end

-- ajoute une goutte d'eau
function new_goutte(v, hp)
 local a = get_angle()
 if (a ~= 4) then
   table.insert(gouttes, {x = POS_X, y = POS_Y, v0_sin = v*(math.sin(a)), v0_cos = v*(math.cos(a)), t = 0, hp = hp})
 end
end

-- ajoute un message
function new_message(x, y, t)
 table.insert(messages, {x = x+2, y = y-5, typ = t, t = 30})
end

-- affichage complet
function affichage()
 screen:clear()
 screen:blit(0,0,Imfond)
 for i,v in ipairs(feux) do print_feu(v) end
 screen:blit(0,0,Imimmeuble)
 for i,v in ipairs(personages) do print_perso2(v) end
 screen:blit(echelle.x,echelle.y, Imechelle)
 for i,v in ipairs(personages) do print_perso(v) end
 for i,v in ipairs(personages) do print_perso3(v) end
 for i,v in ipairs(messages) do print_message(i,v) end
 for i,v in ipairs(gouttes) do print_goutte(v) end

 -- info du jeu

 dizaine1 = math.floor(nbSauves/10) 
 unite1 = math.mod(nbSauves, 10) 
 dizaine2 = math.floor(nbMorts/10) 
 unite2 = math.mod(nbMorts, 10) 

 if dizaine1==0 then screen:blit (155, 62,n0) end 
 if dizaine1==1 then screen:blit (155, 62,n1) end 
 if dizaine1==2 then screen:blit (155, 62,n2) end 
 if dizaine1==3 then screen:blit (155, 62,n3) end 
 if dizaine1==4 then screen:blit (155, 62,n4) end 
 if dizaine1==5 then screen:blit (155, 62,n5) end 
 if dizaine1==6 then screen:blit (155, 62,n6) end 
 if dizaine1==7 then screen:blit (155, 62,n7) end 
 if dizaine1==8 then screen:blit (155, 62,n8) end 
 if dizaine1==9 then screen:blit (155, 62,n9) end 
 if unite1==0 then screen:blit (170, 62,n0) end 
 if unite1==1 then screen:blit (170, 62,n1) end 
 if unite1==2 then screen:blit (170, 62,n2) end 
 if unite1==3 then screen:blit (170, 62,n3) end 
 if unite1==4 then screen:blit (170, 62,n4) end 
 if unite1==5 then screen:blit (170, 62,n5) end 
 if unite1==6 then screen:blit (170, 62,n6) end 
 if unite1==7 then screen:blit (170, 62,n7) end 
 if unite1==8 then screen:blit (170, 62,n8) end 
 if unite1==9 then screen:blit (170, 62,n9) end

 if dizaine2==0 then screen:blit (155, 175,n0) end 
 if dizaine2==1 then screen:blit (155, 175,n1) end 
 if dizaine2==2 then screen:blit (155, 175,n2) end 
 if dizaine2==3 then screen:blit (155, 175,n3) end 
 if dizaine2==4 then screen:blit (155, 175,n4) end 
 if dizaine2==5 then screen:blit (155, 175,n5) end 
 if dizaine2==6 then screen:blit (155, 175,n6) end 
 if dizaine2==7 then screen:blit (155, 175,n7) end 
 if dizaine2==8 then screen:blit (155, 175,n8) end 
 if dizaine2==9 then screen:blit (155, 175,n9) end 
 if unite2==0 then screen:blit (170, 175,n0) end 
 if unite2==1 then screen:blit (170, 175,n1) end 
 if unite2==2 then screen:blit (170, 175,n2) end 
 if unite2==3 then screen:blit (170, 175,n3) end 
 if unite2==4 then screen:blit (170, 175,n4) end 
 if unite2==5 then screen:blit (170, 175,n5) end 
 if unite2==6 then screen:blit (170, 175,n6) end 
 if unite2==7 then screen:blit (170, 175,n7) end 
 if unite2==8 then screen:blit (170, 175,n8) end 
 if unite2==9 then screen:blit (170, 175,n9) end

end

-- donne l'angle form par le pad analogique
function get_angle()
 local pad = Controls.read()
 local x = pad:analogX()
 local y = pad:analogY()

 -- calcul de l'angle
 if (x < 0) then
  local a = math.asin(y/128)
  return -(math.pi -a)
 else return 4
 end
end

-- fais bouger les gouttes
function bouge_gouttes()
 for i,g in ipairs(gouttes) do
  g.t = g.t+1
  g.x = (g.v0_cos * g.t) + POS_X
  g.y = -(0.5 * -GRAVITE * g.t * g.t +  g.v0_sin * g.t) + POS_Y
  -- verif que la goutte est pas sortie
  if (g.x < 10 or g.x > 470 or g.y < 0 or g.y > 272) then
   table.remove(gouttes,i)
  end -- fin du if
 end -- fin du for
end

-- gere les interraction gouttes / feux
function eteint()
 for i,g in ipairs(gouttes) do
  for j, f in ipairs(feux) do
   local xf = fenetres[f.idFen].x
   local yf = fenetres[f.idFen].y
   -- regarde si la goutte est sur le feu
   if ((g.x+3 > xf - TAILLEFEU/2) and (g.x-3 < xf + TAILLEFEU/2) and (g.y+3 > yf - TAILLEFEU) and (g.y-3 < yf)) then
     f.hp = f.hp - g.hp
     if (f.hp <= 0) then
      if fenetres[f.idFen].etat == BRULE then fenetres[f.idFen].etat = OK
      else
        fenetres[f.idFen].etat = PERSO
        new_message(fenetres[f.idFen].x + TAILLE/2, fenetres[f.idFen].y - (TAILLE +20) , 1)
      end
      table.remove(feux, j)
     end
     table.remove(gouttes, i)
     break
   end
  end -- fin du for (feux)
 end -- fin du for (gouttes)
end


-- fait bruler les persos
function persoBrule()
 for i, p in ipairs(personages) do
  if (fenetres[p.idFen].etat == PERSO_BRULE) then
   p.hp = p.hp - 1
   if (p.hp < 0) then
    p.etat = 3
    nbMorts = nbMorts+1
    fenetres[p.idFen].etat = BRULE
   end
  end
 end
end

-- fait apparaitre les anges
function anges()
 for i, p in ipairs(personages) do
  if (p.etat == 3) then
   p.y = fenetres[p.idFen].y - TAILLEPERSO -5
   p.etat = 4
   end
   if (p.etat == 4) then
   p.y = p.y - 2
   if p.y <= -60 then 
   table.remove(personages, i)
   end
   end
 end
end

-- ajoute des feux dans les fenetres libres
function ajout_feu()
 for i = 1 , NBFEN, 1 do
  if (fenetres[i].etat == OK or fenetres[i].etat == PERSO) then
   local prob = proba(0,4)
   if (prob==1) then new_feu(i,40) end
  end
 end
end

-- ajoute des perso dans les fenetres libres
function ajout_perso()
 for i = 1 , NBFEN, 1 do
  for i, f in ipairs(fenetres) do
   if (fenetres[i].etat == OK) then
   local prob = proba(0,8)
    if (prob==1) then
     if (echelle.x < f.x -20 or echelle.x > f.x-2) and (echelle.y < f.y -12 or echelle.y > f.y) then 
     new_perso(i,200)
     end 
    end
   end
  end
 end
end

-- donne le numero de la fenetre dans laquelle se trouve l'echelle -1 sinon
function positionEchelle()
 local res = -1
 for i, f in ipairs(fenetres) do
   if (echelle.x > f.x -20 and echelle.x < f.x-2 and echelle.y > f.y -12 and echelle.y < f.y) then
     res =  i
     break
    end
 end
 return res
end

-- change l'etat d'un perso
function sauvePerso()
  for i, p in ipairs(personages) do
    local f = positionEchelle()
    if (f == p.idFen and fenetres[p.idFen].etat == PERSO) then
     fenetres[f].etat = OK
     p.etat = 1
     p.x = echelle.x 
     p.y = echelle.y - 4
     nbSauves = nbSauves +1
     return
    end
  end
end

-- bouge l'echelle
function bougeEchelle()
 pad = Controls.read()
 local decx = 0
 local decy = 0
 if (pad:square() and echelle.x > 225) then
  echelle.x = echelle.x - 2
  decx = decx - 2
 end
 if (pad:circle() and echelle.x < 470) then
  echelle.x = echelle.x + 2
  decx = decx + 2
 end
 if (pad:triangle() and echelle.y > 0) then
  echelle.y = echelle.y - 2
  decy = decy - 2
 end
 if (pad:cross() and echelle.y < 272) then
  echelle.y = echelle.y + 2
  decy = decy + 2
 end
 -- repercute le mvt sur les perso sur l'echelle
 for i, p in ipairs(personages) do
  if (p.etat == 1) then
   p.x = p.x + decx
   p.y = p.y + decy + 0.5
  end
  if (p.etat == 2) then
   p.x = p.x + decx
   p.y = p.y + decy + 0.5
  end
 end
end

-- fais bouger les perso en mvt
function bougePerso()
 for i,p in ipairs(personages) do
  -- perso sur l'echelle
  if(p.etat == 2) then
   p.y = p.y + 2.5
   if(p.y > 272) then table.remove(personages, i) end
  end
  -- perso sur l'echelle
  if(p.etat == 1) then
   p.y = p.y + 2.5
   if(p.y > 249) then
    p.etat = 2
    p.y = 250
    new_message(p.x+18, p.y, 2)
   end
  end
 end
end

-- pause
function pause() 
while true do
screen:clear()
screen:blit(0, 0, Impausefond)
screen:blit(128, 62, Impause) 
pad = Controls.read() 
if pad:cross() then 
frommenu=false  
screen.waitVblankStart() 
screen:flip() 
break 
end  
if pad:triangle() then
Music.stop() 
dofile ("menu.lua")
break
end 
screen.waitVblankStart() 
screen:flip() 
end
end

-----------------------------------------
----------  tests   ---------------------
-----------------------------------------
for i = 1, NBFEN, 2 do
 new_feu(i, 40)
end

for i = 2, NBFEN, 2 do
 new_perso(i, 200)
end

cpt = 0

while CONTINUER == true do
 pad = Controls.read()
 if (pad:l() or pad:r()) then new_goutte(14,5) end
 bougeEchelle()
 bougePerso()
 sauvePerso()
 bouge_gouttes()
 eteint()
 persoBrule()
 anges()
 if (cpt == 0) then
  ajout_feu()
  ajout_perso()
 end
 
 affichage()
 screen.flip()
 screen.waitVblankStart()
 if pad:select() then screen:save("shot.png") end
 if pad:start() then 
 pause()
 end
 cpt = cpt+1
 if (cpt > 100) then cpt = 0 end

if (nbSauves == 25 and nbMorts <= 5) then 
statut = "victoire"
CONTINUER = false
end

if (nbMorts > 5) then 
statut = "defaite"
CONTINUER = false
end

end --fin du while

while CONTINUER == false do
screen:clear()
screen:blit(0, 0, Imfond)
pad = Controls.read()

if (statut == "victoire") then
screen:blit(100, 10, Imgagne)
 if pad:start() then
 Music.stop()
 Selectniveau = 3
 if (Selectniveau > maxSelectniveau) then
 maxSelectniveau =3
 end
 dofile("menu2.lua")
 break
 end
screen.flip()
screen.waitVblankStart()
end
if (statut == "defaite") then
screen:blit(100, 10, Imperdu)
 if pad:start() then
 Music.stop()
 dofile("menu.lua")
 break
 end
screen.flip()
screen.waitVblankStart()
end

end 